## icewm 1.4.3.0~pre

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
IF (POLICY CMP0053) # in CMake 3.1.0+
  CMAKE_POLICY (SET CMP0053 OLD) # keep old-style @VAR@ expansion
ENDIF (POLICY CMP0053)
PROJECT(ICEWM CXX C)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})

set(PROJECT_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})

IF(NOT DEFINED(CMAKE_INSTALL_PREFIX))
set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE STRING "Target file space")
ENDIF()
# iiieh, neeing to add some guards, since having this nested construct
# interacts badly when changing a variable afterwards cmake also insists on
# overwritting that variables later :-( if not protected
IF(NOT DEFINED(DATADIR))
set(DATADIR "${CMAKE_INSTALL_PREFIX}/share" CACHE STRING "Shared data files directory")
ENDIF()
IF(NOT DEFINED(LIBDIR))
	set(LIBDIR "${DATADIR}/icewm" CACHE STRING "Location of icewm meta data")
ENDIF()
IF(NOT DEFINED(DOCDIR))
	set(DOCDIR "${DATADIR}/doc/icewm" CACHE STRING "Location of documentation files")
ENDIF()
IF(NOT DEFINED(LOCDIR))
	set(LOCDIR "${DATADIR}/locale" CACHE STRING "System locale data directory")
ENDIF()
IF(NOT DEFINED(CFGDIR))
	set(CFGDIR "${CMAKE_INSTALL_PREFIX}/etc/icewm" CACHE STRING "Location of system-wide configuration files")
ENDIF()
IF(NOT DEFINED(ICEHELPIDX))
	set(ICEHELPIDX "${DOCDIR}/icewm.html" CACHE STRING "Location of HTML manual entry page")
ENDIF()
IF(NOT DEFINED(BINDIR))
set(BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
ENDIF()

find_package(Git)
find_program(SED_EXECUTABLE sed)

if(Git_FOUND AND IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
	execute_process(COMMAND "${GIT_EXECUTABLE}" "describe" "--tags"
		COMMAND "${SED_EXECUTABLE}" "s,[-_],.,g;s,\\.g.*$,,"
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		OUTPUT_VARIABLE VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	set(PACKAGE "icewm")
else()
	FILE(READ "${CMAKE_SOURCE_DIR}/VERSION" vfilecontents)
	STRING(REGEX REPLACE "\n" ";" vfilecontents "${vfilecontents}")
	foreach (line ${vfilecontents})
		STRING(REGEX REPLACE "=" ";" keyval "${line}")
		list(GET keyval 0 _key)
		IF(NOT DEFINED ${_key})
			list(GET keyval 1 ${_key})
		ENDIF()
	endforeach()
endif()


add_subdirectory(src)
add_subdirectory(po)
add_subdirectory(lib)
add_subdirectory(doc)
add_subdirectory(man)

install(FILES icewm-set-gnomewm contrib/icewm-menu-xrandr DESTINATION ${BINDIR} PERMISSIONS WORLD_EXECUTE OWNER_EXECUTE GROUP_EXECUTE WORLD_READ OWNER_READ OWNER_WRITE GROUP_READ)

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT(ICEWM CXX)

#
# Which themes to install in alphabetical order
#
set(themesList CrystalBlue Helix Infadel2 NanoBlue
    default icedesert metal2 motif win95)

foreach(_src keys menu programs toolbar winoptions)
   CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/${_src}.in" "${CMAKE_CURRENT_BINARY_DIR}/${_src}")
   install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${_src}" DESTINATION "${LIBDIR}")
endforeach()

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/icewm.desktop" DESTINATION "${DATADIR}/xsessions/")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/icewm-session.desktop" DESTINATION "${DATADIR}/xsessions/")

install(DIRECTORY mailbox taskbar icons ledclock
        DESTINATION "${LIBDIR}"
        FILES_MATCHING PATTERN "*"
        PATTERN "*.in" EXCLUDE)

foreach(theme ${themesList})
    install(DIRECTORY "themes/${theme}"
            DESTINATION "${LIBDIR}/themes")
endforeach()

=== man/CMakeLists.txt ===
#
# The destination directory for manpages.
#
if(NOT MANDIR)
    set(MANDIR "${DATADIR}/man")
endif()

macro(Pod2Man name sectionId sectionName)
        string(REGEX REPLACE "\\.man$" ".pod" podName "${name}")
        string(REGEX REPLACE "\\.man$" ".${sectionId}" manName "${name}")
        ADD_CUSTOM_COMMAND(
                OUTPUT ${manName}
                DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${podName}
                COMMAND pod2man ARGS --center="${sectionName}"
                --errors="none"
                --fixed="CW"
                --fixedbold="CB"
                --fixeditalic="CI"
                --fixedbolditalic="CX"
                --nourls
                --release="${PACKAGE} ${VERSION}" --section="${sectionId}"
                ${CMAKE_CURRENT_SOURCE_DIR}/${podName} ${manName}
                )
        INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${manName} DESTINATION "${MANDIR}/man${sectionId}")
        list(APPEND MAN_RESULTS ${manName})
endmacro()

set(icewm_man1_files
	icesh.man
	icewmbg.man
	icewmhint.man
	icewm.man
	icewm-session.man
	icewm-set-gnomewm.man
	icewmtray.man
  )

set(extra_man1_files
	icehelp.man
	icesound.man
	icewm-menu-fdo.man
	icewm-menu-xrandr.man
  )

set(icewm_man5_files
	icewm-env.man
	icewm-focus_mode.man
	icewm-keys.man
	icewm-menu.man
	icewm-preferences.man
	icewm-prefoverride.man
	icewm-programs.man
	icewm-shutdown.man
	icewm-startup.man
	icewm-theme.man
	icewm-toolbar.man
	icewm-winoptions.man
  )

foreach(x ${icewm_man1_files} ${extra_man1_files})
        Pod2Man(${x} 1 "User Commands")
endforeach()

foreach(x ${icewm_man5_files})
        Pod2Man(${x} 5 "Standards, Environments and Macros")
endforeach()

ADD_CUSTOM_TARGET(manpages ALL DEPENDS ${MAN_RESULTS})

=== po/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT(ICEWM CXX)

# yes, FindGettext.cmake exists but it's not really handy :-(
# XXX: document -DEXTRA_MSGMERGE=--verbose -DEXTRA_MSGFMT=--verbose

SET(EXTRA_MSGMERGE "--quiet")

find_program(gettext gettext)
find_program(xgettext xgettext)
find_program(msgmerge msgmerge)
find_program(msgfmt msgfmt)

if(gettext AND xgettext AND msgmerge AND msgfmt)
	# source files, read-only!
	FILE(GLOB SRCS "${CMAKE_SOURCE_DIR}/src/*.cc")
	foreach(_src ${SRCS})
		get_filename_component(_src "${_src}" NAME)
		LIST(APPEND SRCSRELATIVE "src/${_src}")
	endforeach()
	FILE(GLOB POS "${CMAKE_CURRENT_SOURCE_DIR}/*.po")
	foreach(_src ${POS})
		get_filename_component(_src "${_src}" NAME_WE)
		LIST(APPEND LANGUAGES ${_src})
	endforeach()

	#message("langs: ${LANGUAGES}")
	SET(XGETTEXT_CMD xgettext --from-code=UTF-8 -language=CXX --add-comments=TRANSLATORS: --keyword=_ --keyword=N_ -s --package-name=${PACKAGE} --package-version=${VERSION})
  SET(_potFile "${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE}.pot")

	ADD_CUSTOM_COMMAND(OUTPUT stamp-potfile
		COMMAND ${XGETTEXT_CMD} -o "${_potFile}" ${SRCSRELATIVE}
		DEPENDS ${SRCS}
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		COMMENT "Extracting translatable messages to ${_potFile} -- may require config restart!")
	ADD_CUSTOM_TARGET(update_pot DEPENDS stamp-potfile)

  if(EXISTS ${_potFile})

	if(SKIP_TRANSLATIONS)
		ADD_CUSTOM_TARGET(translations)
	else()
		ADD_CUSTOM_TARGET(translations ALL)
	endif()

	foreach(_lang ${LANGUAGES})
		SET(_tempPO "${CMAKE_CURRENT_BINARY_DIR}/${_lang}.po")
		ADD_CUSTOM_COMMAND(OUTPUT ${_tempPO}
			COMMAND msgmerge -o ${_tempPO} ${EXTRA_MSGMERGE} -s ${CMAKE_CURRENT_SOURCE_DIR}/${_lang}.po ${_potFile}
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			COMMENT "Updated: ${_tempPO}")
		ADD_CUSTOM_TARGET(${_lang}.po DEPENDS ${_tempPO})

		SET(_tempMO "${CMAKE_CURRENT_BINARY_DIR}/${_lang}.gmo")
		ADD_CUSTOM_COMMAND(OUTPUT ${_tempMO}
			COMMAND msgfmt -o ${_tempMO} ${EXTRA_MSGFMT} ${_tempPO}
			DEPENDS ${_tempPO}
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
		#COMMENT "Compiled: ${_tempMO}")
		ADD_CUSTOM_TARGET(${_lang}.gmo DEPENDS ${_tempMO})
		install(FILES ${_tempMO} DESTINATION "${LOCDIR}/${_lang}/LC_MESSAGES/" RENAME "${PACKAGE}.mo" OPTIONAL)
		add_dependencies(translations ${_lang}.gmo)
	endforeach()

  endif()

endif()

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

PROJECT(ICEWM CXX)

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckTypeSize)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(FindPkgConfig)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckCXXCompilerFlag)

SET(CXXFLAGS_COMMON "-pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -I. -DHAVE_CONFIG_H")

set(icewm_img_libs "")
set(icewm_libs "")

if("${CMAKE_BUILD_TYPE}" STREQUAL "" AND ("" STREQUAL "${CMAKE_CXX_FLAGS}"))
    SET(CMAKE_BUILD_TYPE Release)
endif()

if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    add_definitions(-DDEBUG)
endif()

# carefully splicing of command line arguments, even from lists
macro(_append varname)
    string(REPLACE ";" " " _apx "${ARGN}")
    if(NOT DEFINED ${varname})
        set(${varname} "${_apx}")
    else()
        set(${varname} "${${varname}} ${_apx}")
    endif()
endmacro()

# I don't need -rdynamic, thanks!
SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")

# apply to test calls
SET(CMAKE_REQUIRED_FLAGS ${CXXFLAGS_COMMON})

CHECK_CXX_COMPILER_FLAG(-fvisibility=hidden CXX_VHI)
if(CXX_VHI)
    _append(CXXFLAGS_COMMON -fvisibility=hidden)
endif()

CHECK_CXX_COMPILER_FLAG(-fvisibility-inlines-hidden CXX_VIHI)
if(CXX_VIHI)
    _append(CXXFLAGS_COMMON -fvisibility-inlines-hidden)
endif()

CHECK_CXX_COMPILER_FLAG(-std=gnu++98 CXX_FORCELEGACY)
if(CXX_FORCELEGACY)
    _append(CXXFLAGS_COMMON -std=gnu++98)
endif()

#CHECK_CXX_COMPILER_FLAG(-Wl,-fuse-ld=gold CXX_LINKER_GOLD)
#if(CXX_LINKER_GOLD)
#    list(APPEND icewm_libs -Wl,-fuse-ld=gold)
#endif()

option(CONFIG_LIBPNG "(Experimental) PNGLIB image loader" on)
option(CONFIG_LIBJPEG "JPEGLIB image loader" on)
option(CONFIG_GDK_PIXBUF_XLIB "GDK-PIXBUF based image loader" off)
option(CONFIG_LIBRSVG "(Optional) SVG image loader" off)
option(CONFIG_XPM "(Optional) XPM image loader" on)
option(CONFIG_I18N "Define to enable internationalization" on)
option(CONFIG_RENDER "Define to enable XRENDER extension" on)
option(CONFIG_XRANDR "Define to enable XRANDR extension" on)
option(CONFIG_SESSION "Define to enable X session management" on)
option(CONFIG_EXTERNAL_TRAY "Define to build tray support in standalone executable" off)
option(ENABLE_NLS "Enable Native Language Support" on)
option(ENABLE_LTO "Enable Link Time Optimization" off)

SET(CONFIG_DEFAULT_THEME "default/default.theme" CACHE STRING "Name of default theme")
SET(CONFIG_UNICODE_SET "" CACHE STRING "Your iconv unicode set in machine endian encoding (e.g. WCHAR_T, UCS-4-INTERNAL, UCS-4LE, UCS-4BE)")
# turn off when empty, see config.h template for details
IF("" STREQUAL "${CONFIG_UNICODE_SET}")
    SET(CONFIG_UNICODE_SET OFF)
ELSE()
    MESSAGE(STATUS "Configured custom unicode set: ${CONFIG_UNICODE_SET}.")
ENDIF()

# TODO: find some common helper to handle that variables
if(ENABLE_NLS OR CONFIG_I18N)
    find_library(CONFIG_LIBICONV iconv)
    if(CONFIG_LIBICONV)
        LIST(APPEND nls_LIBS iconv)
    endif()
    find_library(CONFIG_LIBINTL intl)
    if(CONFIG_LIBINTL)
        LIST(APPEND nls_LIBS intl)
    endif()
endif()

if(ENABLE_LTO)
    set(CXXFLAGS_COMMON "${CXXFLAGS_COMMON} -flto")
    list(APPEND EXTRA_LIBS -flto)
endif()

# the only used ones...
# for x in `cat funclist` ; do grep $x src/* lib/* && echo $x >> exlist ; done
# perl -e 'print "CHECK_FUNCTION_EXISTS($_ HAVE_".uc($_).")\n" for @ARGV' `cat exlist`
# perl -e 'print "#cmakedefine HAVE_".uc($_)."\n" for @ARGV' `cat exlist`
CHECK_FUNCTION_EXISTS(abort HAVE_ABORT)
CHECK_FUNCTION_EXISTS(backtrace_symbols_fd HAVE_BACKTRACE_SYMBOLS_FD)
CHECK_FUNCTION_EXISTS(basename HAVE_BASENAME)
CHECK_FUNCTION_EXISTS(dup2 HAVE_DUP2)
CHECK_FUNCTION_EXISTS(gethostbyname HAVE_GETHOSTBYNAME)
CHECK_FUNCTION_EXISTS(gethostname HAVE_GETHOSTNAME)
CHECK_FUNCTION_EXISTS(getloadavg HAVE_GETLOADAVG2)
CHECK_FUNCTION_EXISTS(gettimeofday HAVE_GETTIMEOFDAY)
CHECK_FUNCTION_EXISTS(mblen HAVE_MBLEN)
CHECK_FUNCTION_EXISTS(memchr HAVE_MEMCHR)
CHECK_FUNCTION_EXISTS(memmove HAVE_MEMMOVE)
CHECK_FUNCTION_EXISTS(memset HAVE_MEMSET)
CHECK_FUNCTION_EXISTS(mkdir HAVE_MKDIR)
CHECK_FUNCTION_EXISTS(nl_langinfo HAVE_NL_LANGINFO)
CHECK_FUNCTION_EXISTS(select HAVE_SELECT)
CHECK_FUNCTION_EXISTS(setlocale HAVE_SETLOCALE)
CHECK_FUNCTION_EXISTS(socket HAVE_SOCKET)
CHECK_FUNCTION_EXISTS(strcasecmp HAVE_STRCASECMP)
CHECK_FUNCTION_EXISTS(strchr HAVE_STRCHR)
CHECK_FUNCTION_EXISTS(strcspn HAVE_STRCSPN)
CHECK_FUNCTION_EXISTS(strdup HAVE_STRDUP)
CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR)
CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
CHECK_FUNCTION_EXISTS(strlcat HAVE_STRLCAT)
CHECK_FUNCTION_EXISTS(strncasecmp HAVE_STRNCASECMP)
CHECK_FUNCTION_EXISTS(strrchr HAVE_STRRCHR)
CHECK_FUNCTION_EXISTS(strsignal HAVE_STRSIGNAL)
CHECK_FUNCTION_EXISTS(strspn HAVE_STRSPN)
CHECK_FUNCTION_EXISTS(strstr HAVE_STRSTR)
CHECK_FUNCTION_EXISTS(strtol HAVE_STRTOL)
CHECK_FUNCTION_EXISTS(strtoul HAVE_STRTOL)
CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
CHECK_FUNCTION_EXISTS(strlcat HAVE_STRLCAT)
CHECK_FUNCTION_EXISTS(sysctlbyname HAVE_SYSCTLBYNAME)
CHECK_FUNCTION_EXISTS(sysinfo HAVE_SYSINFO)
CHECK_FUNCTION_EXISTS(uname HAVE_UNAME)
CHECK_FUNCTION_EXISTS(wordexp HAVE_WORDEXP)
CHECK_FUNCTION_EXISTS(if_indextoname HAVE_IF_INDEXTONAME)
CHECK_FUNCTION_EXISTS(nameindex HAVE_IF_NAMEINDEX)
CHECK_FUNCTION_EXISTS(if_nametoindex HAVE_IF_NAMETOINDEX)

CHECK_LIBRARY_EXISTS (X11 XInternAtoms "" HAVE_XINTERNATOMS)

# perl -e 'do { s/\.|\//_/g; $_=uc $_;  print "#cmakedefine HAVE_$_\n"} for @ARGV' `cat headersDa`
# perl -e 'do {my $orig=$_; s/\.|\//_/g; $_=uc $_; print "CHECK_INCLUDE_FILE_CXX($orig HAVE_$_)\n"} for @ARGV' `cat headersDa`
CHECK_INCLUDE_FILE_CXX(fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILE_CXX(kstat.h HAVE_KSTAT_H)
CHECK_INCLUDE_FILE_CXX(langinfo.h HAVE_LANGINFO_H)
CHECK_INCLUDE_FILE_CXX(libintl.h HAVE_LIBINTL_H)
CHECK_INCLUDE_FILE_CXX(limits.h HAVE_LIMITS_H)
CHECK_INCLUDE_FILE_CXX(locale.h HAVE_LOCALE_H)
CHECK_INCLUDE_FILE_CXX(netdb.h HAVE_NETDB_H)
CHECK_INCLUDE_FILE_CXX(netinet/in.h HAVE_NETINET_IN_H)
CHECK_INCLUDE_FILE_CXX(sndfile.h HAVE_SNDFILE_H)
CHECK_INCLUDE_FILE_CXX(stddef.h HAVE_STDDEF_H)
CHECK_INCLUDE_FILE_CXX(stdlib.h HAVE_STDLIB_H)
CHECK_INCLUDE_FILE_CXX(string.h HAVE_STRING_H)
CHECK_INCLUDE_FILE_CXX(strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILE_CXX(sysctl.h HAVE_SYSCTL_H)
CHECK_INCLUDE_FILE_CXX(sys/file.h HAVE_SYS_FILE_H)
CHECK_INCLUDE_FILE_CXX(sys/ioctl.h HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILE_CXX(sys/socket.h HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILE_CXX(sys/sysctl.h HAVE_SYS_SYSCTL_H)
CHECK_INCLUDE_FILE_CXX(sys/time.h HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILE_CXX(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILE_CXX(wchar.h HAVE_WCHAR_H)
CHECK_INCLUDE_FILE_CXX(sched.h HAVE_SCHED_H)
CHECK_INCLUDE_FILE_CXX(sys/sched.h HAVE_SYS_SCHED_H)
CHECK_INCLUDE_FILE_CXX(sys/dkstat.h HAVE_SYS_DKSTAT_H)
CHECK_INCLUDE_FILE_CXX(sys/param.h HAVE_SYS_PARAM_H)
CHECK_INCLUDE_FILE_CXX(uvm/uvm_param.h HAVE_UVM_UVM_PARAM_H)
CHECK_INCLUDE_FILE_CXX(libgen.h HAVE_LIBGEN_H)
CHECK_INCLUDE_FILE_CXX(machine/apmvar.h HAVE_MACHINE_APMVAR_H)
CHECK_INCLUDE_FILE_CXX(machine/apm_bios.h HAVE_MACHINE_APM_BIOS_H)
CHECK_INCLUDE_FILE_CXX(execinfo.h HAVE_EXECINFO_H)

CHECK_TYPE_SIZE(char SIZEOF_CHAR)
CHECK_TYPE_SIZE(long SIZEOF_LONG)
CHECK_TYPE_SIZE(int SIZEOF_INT)
CHECK_TYPE_SIZE(short SIZEOF_SHORT)

#########################################################
# fiting flags to options and available system features #
#########################################################

pkg_check_modules(fontconfig fontconfig)
pkg_check_modules(xext xext)
pkg_check_modules(x11 x11)

# XXX: the image loader selection became a big mess but it is hard to revert now
# It would have been a better idea to use different names for the user-specified
# options and do the logics here.
# But for now, this self-adapting code modifies the option variables.

set(HINT_IMG_LOADERS  "Possible combination of image loaders are:
    -DCONFIG_XPM=on -DCONFIG_LIBPNG=on -DCONFIG_GDK_PIXBUF_XLIB=off
    or
    -DCONFIG_XPM=off -DCONFIG_LIBPNG=off -DCONFIG_GDK_PIXBUF_XLIB=on
")
# basic user configuration error check
if(CONFIG_GDK_PIXBUF_XLIB AND NOT CONFIG_XPM)
    #ok
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    if (NOT CONFIG_LIBRSVG)
        message(WARNING "CONFIG_LIBRSVG is recommended for SVG image support")
    endif()
elseif(CONFIG_XPM AND NOT CONFIG_GDK_PIXBUF_XLIB)
    #ok
    if (NOT CONFIG_LIBPNG)
        message(WARNING "LIBPNG is recommended for PNG image support")
    endif()
    if (NOT CONFIG_LIBJPEG)
        message(WARNING "LIBJPEG is advisable for backgrounds in icewmbg")
    endif()
else()
    MESSAGE(FATAL_ERROR "${HINT_IMG_LOADERS}")
endif()

if(CONFIG_GDK_PIXBUF_XLIB)
    pkg_check_modules(pixbuf gdk-pixbuf-xlib-2.0)
    if(NOT pixbuf_FOUND)
        message(FATAL_ERROR "GDX-PIXBUF image loader selected but its dev files were not found.
${HINT_IMG_LOADERS}")
    endif()
    set(CONFIG_XPM off)
    set(CONFIG_LIBPNG off)
    set(CONFIG_IMLIB off)
    set(CONFIG_LIBJPEG off)
    LIST(APPEND icewm_img_libs ${pixbuf_LDFLAGS})
endif()

# this is a) optional, b) loaded through pixbuf anyway
if (CONFIG_LIBRSVG)
    pkg_check_modules(librsvg librsvg-2.0)
    if(NOT librsvg_FOUND)
        message(WARNING "SVG image loader selected but librsvg dev files not found. SVG support will be not available.")
        set(CONFIG_LIBRSVG off)
    endif()
    LIST(APPEND icewm_img_libs ${librsvg_LDFLAGS})
endif()

if(CONFIG_XPM)
    pkg_check_modules(libxpm xpm)
    if(NOT libxpm_FOUND)
        message(FATAL_ERROR "XPM image loader selected but libxpm dev files not found.
${HINT_IMG_LOADERS}")
    endif()
    LIST(APPEND icewm_img_libs ${libxpm_LDFLAGS})
endif()

if(CONFIG_LIBPNG)
    pkg_check_modules(libpng libpng)
    if(NOT libpng_FOUND)
        message(FATAL_ERROR "PNG image loader selected but libpng dev files not found.
${HINT_IMG_LOADERS}")
    endif()
    LIST(APPEND icewm_img_libs ${libpng_LDFLAGS})
endif()

if(CONFIG_LIBJPEG)
    pkg_check_modules(libjpeg libjpeg)
    if(NOT libjpeg_FOUND)
        message(FATAL_ERROR "JPEG image loader selected but libjpeg dev files not found.
${HINT_IMG_LOADERS}")
    endif()
    LIST(APPEND icewm_img_libs ${libjpeg_LDFLAGS})
endif()

IF(CONFIG_SESSION)
    LIST(APPEND sm_LIBS SM)
    LIST(APPEND sm_LIBS ICE)
ENDIF()

option(CONFIG_SHAPE "Define to enable transparent frame	decoration (titlebar borders), requests X shape extension." on)
# TODO: check the symbol: AC_CHECK_LIB([Xext],[XShapeCombineRectangles],
if(CONFIG_SHAPE AND NOT xext_FOUND)
    message(WARNING "Xext library not found, disabling CONFIG_SHAPE")
    set(CONFIG_SHAPE off)
endif()

if(CONFIG_XRANDR)
    pkg_check_modules(xrandr xrandr)
    IF(NOT xrandr_FOUND)
        message(WARNING "Xrandr library not found, disabling CONFIG_XRANDR")
        set(CONFIG_XRANDR off)
    ENDIF()
endif()

if(CONFIG_RENDER)
    pkg_check_modules(xrender xrender)
    IF(NOT xrender_FOUND)
        message(WARNING "Xrender library not found, disabling CONFIG_RENDER")
        set(CONFIG_RENDER off)
    ENDIF()
    LIST(APPEND icewm_img_libs ${xrender_LDFLAGS})
endif()

option(CONFIG_COREFONTS "Define to enable X11 core fonts" off)
option(CONFIG_XFREETYPE "Define to enable XFT support" on)
if(CONFIG_XFREETYPE)
    pkg_check_modules(xft xft>=2.0)
    IF(NOT xft_FOUND)
        message(WARNING "xft library (>=2.0) not found, disabling CONFIG_XFREETYPE")
        set(CONFIG_XFREETYPE off)
        set(CONFIG_COREFONTS on)
    ELSE()
        set(CONFIG_XFREETYPE_VALUE 2)
    ENDIF()
else()
    set(CONFIG_COREFONTS on)
endif()

set(ICESOUND "ALSA,AO,OSS,ESound" CACHE STRING "List of supported audio subsystems")
string(TOLOWER ${ICESOUND} ICESOUND)
message(STATUS "Checking audio subsystems from ICESOUND: ${ICESOUND}")

#clear cache
set(ENABLE_ALSA off)
set(ENABLE_AO off)
set(ENABLE_ESD off)
set(ENABLE_OSS off)
set(audio_libs )
set(audio_flags )

## icewm 1.4.3.0~pre-20180217

=== debian/changelog ===
icewm (1.4.3.0~pre-20180217-3) unstable; urgency=medium

  * Adding missing libjpeg-dev build-dependency

 -- Eduard Bloch <blade@debian.org>  Wed, 28 Feb 2018 20:16:54 +0100

icewm (1.4.3.0~pre-20180217-2) unstable; urgency=medium

  * New upstream snapshot
  * Fixed export of CONFIG_LIBJPEG in source code (closes: #891737)

 -- Eduard Bloch <blade@debian.org>  Wed, 28 Feb 2018 18:41:58 +0100

icewm (1.4.3.0~pre-20180217-1) unstable; urgency=low

  * New upstream snapshot
  * Uploading to Sid, pros should outweigh the cons by now
  * Use automatic icon name resolution for applications managed via
    alternatives mechanism, stops showing wrong/missing icons
  * More build-deps (perl for pod based manpages)

 -- Eduard Bloch <blade@debian.org>  Sat, 17 Feb 2018 19:20:05 +0100

icewm (1.4.3.0~pre-20171225-1) experimental; urgency=low

  * New upstream snapshot
  * Finally switched to direct PNG&XPM loader
  * Changed build to create just one flavor. icewm-lite is now simulated
    through runtime default configuration.

 -- Eduard Bloch <blade@debian.org>  Mon, 25 Dec 2017 22:42:23 +0100

icewm (1.4.3.0~pre-20171204-3) experimental; urgency=low

  * Upstream patch: Fix the build in case where icesound is not enabled

 -- Eduard Bloch <blade@debian.org>  Tue, 05 Dec 2017 20:04:51 +0100

icewm (1.4.3.0~pre-20171204-2) experimental; urgency=low

  * Patch and actually build fix: Back to PIXBUF as default image loader, the
    new PNG+XPM is not sufficient

 -- Eduard Bloch <blade@debian.org>  Tue, 05 Dec 2017 08:03:21 +0100

icewm (1.4.3.0~pre-20171204-1) experimental; urgency=low

  * New upstream snapshot
    - dropped icewmtray binary (not built-in feature)

 -- Eduard Bloch <blade@debian.org>  Mon, 04 Dec 2017 19:07:38 +0100

icewm (1.4.3.0~pre-20171017-1) experimental; urgency=low

  * New upstream snapshot
    + includes FTBFS fixes (closes: #877613)
    + various fixes for colormap handling (#261876 related)
    + manpage updates (mostly in the previous snapshots, closes: #711603)
    + taskbar shouldn't be focusable anymore (closes: #174712)

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_configure pass cross compilers (closes: #850919)

 -- Eduard Bloch <blade@debian.org>  Tue, 17 Oct 2017 19:49:37 +0200

icewm (1.4.3.0~pre-20171002-2) experimental; urgency=low

  * Fix FTBFS due to accidentally removed libsndfile1-dev dependency
  * Change of x-terminal-emulator call to xterm in the "Restart as Xterm"
    function, since this ends deadly with multi-window-single-session
    implementations like terminator (partial fix of #224537)

 -- Eduard Bloch <blade@debian.org>  Mon, 02 Oct 2017 20:39:43 +0200

icewm (1.4.3.0~pre-20171002-1) experimental; urgency=low

  * New upstream snapshot
    - Fixed space allocation below taskbar in certain display setups (thanks to
      Dmitry Semyonov, closes: #874271, #536251)
    - Fixes/Improves automatic discovery of network devices including new
      systemd naming scheme, closes: #801867, #790745)
    - Overhauled icon space allocation (probably closes: #400880)
  * Changed version string (this is preview, 1.4.3 is not released yet)
  * Font size tuning (smaller and less bold)
  * Dropped dependency on libesd (will be used if present through libao,
    detected at runtime; closes: #856080)
  * Documented upstream bug tracker (closes: #802181)
  * Drop deprecated symlink for deprecated themes gtk/gtk2 (closes: #877183)

 -- Eduard Bloch <blade@debian.org>  Mon, 02 Oct 2017 18:51:17 +0200

icewm (1.4.3+mod+20170901-1) experimental; urgency=low

  * New (unofficial fork) upstream snapshot
  * Adding libao-dev build dependency to enable AO support

 -- Eduard Bloch <blade@debian.org>  Fri, 01 Sep 2017 21:33:43 +0200

icewm (1.4.3+mod+20170823-1) experimental; urgency=low

  * New (unofficial fork) upstream snapshot
  * Drop our modifications on font loading (explicite preference for DejaVu)
  * Build rules fixes to use parallelization (stop using dh_auto_build, use
    plain make)

 -- Eduard Bloch <blade@debian.org>  Tue, 08 Aug 2017 21:11:45 +0200

icewm (1.4.1+mod+20170728-1) experimental; urgency=low

  * New (unofficial fork) upstream snapshot

 -- Eduard Bloch <blade@debian.org>  Fri, 28 Jul 2017 16:13:19 +0200

=== debian/control ===
Source: icewm
Section: x11
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>= 9), libxrender-dev, gettext, xfonts-utils, libxft-dev (>> 2.1.1) | libxft2-dev, libsndfile1-dev, libaudiofile-dev, libao-dev, libsm-dev, libx11-dev, libxext-dev, libxinerama-dev, libxrandr-dev, x11proto-core-dev | x-dev, linuxdoc-tools, groff, dpkg-dev (>= 1.16.1~), cmake, asciidoctor, libxpm-dev, libpng-dev, libjpeg-dev (>> 1.2), libglib2.0-dev
Build-Conflicts: libttf-dev
Standards-Version: 4.1.1
Vcs-Git: https://github.com/Code7R/icewm.git

Package: icewm-common
Architecture: any
Conflicts: menu (<< 2.1.9-1)
Replaces: icewm (<< 1.2.14), icewm-gnome-support (<< 1.3.8-3), icewm-themes (<< 1.3.8-3)
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: menu, xscreensaver
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. Can emulate the look of
 Windows'95, OS/2 Warp 3,4, Motif. Tries to take the best features of the above
 systems.
 Features multiple workspaces, opaque move/resize, task bar, window list,
 mailbox status, digital clock. Fast and small.
 .
 This package provides the common files for icewm, icewm-experimental and
 icewm-lite binary packages.

Package: icewm
Architecture: any
Depends: icewm-common (= ${binary:Version}), ${shlibs:Depends}, fonts-dejavu-core | ttf-dejavu-core | custom-icewm-font, ${misc:Depends}
Conflicts: icewm-common (<< 1.3.8-3)
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, digital clock.

Package: icewm-lite
Architecture: any
Depends: icewm-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, digital clock.
 .
 This package provides a minimal icewm binary with no support for
 taskbar and antialiased fonts.

Package: icewm-experimental
Architecture: any
Depends: icewm (= ${binary:Version}), icewm-common (= ${binary:Version}), ${misc:Depends}
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, digital clock.
 .
 This package sometimes provides special IceWm versions with experimental
 features enabled. When the configurations of the packages do not diverge
 it simply enforces an upgrade to the current icewm package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for icewm

ICEWM_COMMON=$(CURDIR)/debian/icewm-common
ICEWM=$(CURDIR)/debian/icewm
ICEWM_LITE=$(CURDIR)/debian/icewm-lite
ICEWM_EXP=$(CURDIR)/debian/icewm-experimental
DOCDIR=/usr/share/doc/icewm-common
BDIR=builddir
ICONS=$(CURDIR)/debian/icons
FDO=$(CURDIR)/debian/fdo
CUSTOM=$(CURDIR)/debian/custom
cmakeargs = -DDOCDIR=$(DOCDIR) -DHTMLDIR=$(DOCDIR)/html -DICEHELPIDX=/usr/share/doc/icewm-common/html/icewm.html -DCFGDIR=/etc/X11/icewm -DCMAKE_INSTALL_PREFIX=/usr -DVERSION=$(ORIGVERSION) -DCMAKE_VERBOSE_MAKEFILE=ON
#-DEXTRA_LIBS="-lsupc++" 
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
-include /usr/share/quilt/quilt.make

CXXFLAGS += $(CPPFLAGS) -DXTERMCMD=x-terminal-emulator -Wall -Wextra
ifeq (linux,$(DEB_TARGET_ARCH_OS))
	 CXXFLAGS += -DUSE_SIGNALFD
endif

%:
	dh $@ --parallel -Scmake

# DEBVERSION=$(shell dpkg-parsechangelog -SVersion)
# that one also works with wheezy
DEBVERSION := $(shell dpkg-parsechangelog |grep ^Version | sed -e s,Version:.,,)
ORIGVERSION := $(shell echo $(DEBVERSION) | sed -e 's,-[^-]*$$,,' )
ORIGTAG := upstream/$(shell echo $(ORIGVERSION) | sed -e 's,~,,g' )

# dh_auto_build is no help here...
PAROPT=$(shell echo $$DEB_BUILD_OPTIONS | sed -e 's,.*parallel=\([0-9]\).*,-j\1,')

#build_lite:
#	$(MAKE) $(PAROPT) -C $(BDIR)-lite
#
#build_normal:
#	$(MAKE) $(PAROPT) -C $(BDIR)-normal

#config_lite:
#	mkdir -p $(BDIR)-lite
#	# this fails on prefering cmake :-( dh_auto_configure --builddirectory=$(BDIR)-lite -- 
#	cd $(BDIR)-lite && cmake .. -DCMAKE_BUILD_TYPE=None $(cmakeargs) -DLITE=on -DEXEEXT=-lite -DCONFIG_XFREETYPE=off -DCONFIG_COREFONTS=on -DXINERAMA=on -DCONFIG_XRANDR=off -DCONFIG_TASKBAR=off -DCONFIG_FDO_MENUS=off -DSKIP_TRANSLATIONS=on -DICESOUND=off
#
#config_normal:
#	mkdir -p $(BDIR)-normal
#	cd $(BDIR)-normal && cmake .. -DCMAKE_BUILD_TYPE=None $(cmakeargs) -DCONFIG_XRANDR=on -DCONFIG_GUIEVENTS=on

override_dh_auto_configure:
	dh_auto_configure -- $(cmakeargs)

#override_dh_auto_configure:
#	$(MAKE) -f debian/rules -j2 config_normal config_lite

#override_dh_auto_build:
#	dh_auto_build
#	cd debian && for x in -lite -experimental ; do cp -lf icewm.postinst icewm$$x.postinst ; cp -lf icewm.prerm icewm$$x.prerm ; done

#override_dh_auto_install:
#	$(MAKE) -C $(BDIR)-lite install DESTDIR=$(CURDIR)/debian/tmp
#	$(MAKE) -C $(BDIR)-normal install DESTDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install
	cd debian && for x in -lite -experimental ; do cp -lf icewm.postinst icewm$$x.postinst ; cp -lf icewm.prerm icewm$$x.prerm ; done
	# XXX: find out why some settings are not gettint defaults if the file is not present, like WorkspaceNames
	#cp $(ICEWM_COMMON)/usr/share/doc/icewm-common/preferences $(ICEWM_COMMON)/usr/share/icewm/
	# Install Debian custom files
	install -m 644 $(ICONS)/mutt*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	install -m 644 $(ICONS)/mozilla*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	install -m 644 $(ICONS)/icewm*.xpm $(ICEWM_COMMON)/usr/share/icewm/icons
	-mv $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.xpm  $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.orig.xpm
	install -m 644 $(ICONS)/debian.xpm $(ICEWM_COMMON)/usr/share/icewm/taskbar/icewm.xpm
	mkdir -p $(ICEWM_COMMON)/usr/bin $(ICEWM_COMMON)/etc/X11/icewm
	install -m 644 $(CUSTOM)/toolbar $(CUSTOM)/menu $(ICEWM_COMMON)/usr/share/icewm
	install -m 644 debian/README.cfg $(ICEWM_COMMON)/usr/share/icewm/README
	# Extra docs
	mkdir -p "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ"
	cd $(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ && sgml2html $(CURDIR)/debian/FAQ/source/*.sgml
	sgml2txt $(CURDIR)/debian/FAQ/source/*.sgml && col -bx < IceWM-FAQ.txt > $(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ/IceWM-FAQ.txt
	cd debian ; for x in icewm icewm-lite icewm-experimental ; do mkdir -p $$x/usr/share/lintian/overrides ; cp $$x.lintian $$x/usr/share/lintian/overrides/$$x ; done	
	sed -e 's,^.link.*fonts.googleapis.*,,' -i "$(ICEWM_COMMON)/usr/share/doc/icewm-common/html/"*.html
	dh_link -A

override_dh_auto_clean:
	rm -rf $(BDIR)-lite $(BDIR)-normal IceWM-FAQ.txt configure.in
	# the variants are just symlinks
	rm -f debian/icewm-*.postinst debian/icewm-*.prerm

override_dh_installchangelogs:
	dh_installchangelogs -picewm-common CHANGES

override_dh_fixperms:
	dh_fixperms
	chmod a+rx,u+w "$(ICEWM_COMMON)/usr/share/doc/icewm-common/examples/startup"

override_dh_compress:
	dh_compress

cleancruft:
	git clean -fdx -e .cproject -e .project -e .settings
	git checkout HEAD -- README.md configure.ac configure.in ChangeLog

set-orig-snapshot:
	lc=$$(git reflog icewm-1-4-BRANCH | head -n1 | cut -f1 -d" ") && dd=$$(date +\%Y\%m\%d) && ov=$$(dpkg-parsechangelog -S Version) && pfx=$$(echo $$ov | sed -e 's,mod.*,mod,') && echo $$lc $$dd $$ov $$pfx && dch --newversion $$pfx+$$dd+$$lc-1

# builds a snapshot of the upstream branch after some plausibility checks
get-orig-source:
	! test -e ../icewm_$(ORIGVERSION).orig.tar.xz || (echo Target already exists ; exit 1)
	lc=`git reflog icewm-1-4-BRANCH | head -n1 | cut -f1 -d" "` && echo "Expected upstream ref: $$lc (on failure run update-debian-mod target)" && grep -m1 ^commit ChangeLog | grep $$lc
	git tag $(ORIGTAG) icewm-1-4-BRANCH
	git archive $(ORIGTAG) --prefix icewm-$(ORIGVERSION)/ | xz -9 > ../icewm_$(ORIGVERSION).orig.tar.xz
	test -d ../tarballs && ln ../icewm_$(ORIGVERSION).orig.tar.xz ../tarballs || true
	pristine-tar commit ../icewm_$(ORIGVERSION).orig.tar.xz icewm-1-4-BRANCH

update-debian-mod:
	grep debian .git/HEAD
	oldstate=$$(head ChangeLog | grep ^commit | head -1 | cut -f2 -d ' ') && git log $$oldstate..icewm-1-4-BRANCH --stat=76 -M -C |fmt -sct -w80 > ChangeLog.debian
	mv ChangeLog ChangeLog.upstream
	cat ChangeLog.debian ChangeLog.upstream > ChangeLog
	rm ChangeLog.debian ChangeLog.upstream
	git commit ChangeLog -m "Updating ChangeLog for a new Debian snapshot"

## icewm 1.4.3.0~pre-20180822

=== debian/changelog ===
icewm (1.4.3.0~pre-20180822-1) unstable; urgency=low

  * New upstream snapshot

 -- Eduard Bloch <blade@debian.org>  Wed, 22 Aug 2018 22:10:15 +0200

icewm (1.4.3.0~pre-20180809-2) unstable; urgency=low

  * Aligned cmake config with the desired image loader selection, also
    enabling SVG support
  * Adding symlink to (default) preferences file to examples folder

 -- Eduard Bloch <blade@debian.org>  Fri, 10 Aug 2018 08:43:10 +0200

icewm (1.4.3.0~pre-20180809-1) unstable; urgency=low

  * Updated upstream snapshot

 -- Eduard Bloch <blade@debian.org>  Thu, 09 Aug 2018 13:03:11 +0200

icewm (1.4.3.0~pre-20180217-4) unstable; urgency=low

  * Restrict supported audio backends to libao (closes: #897595)
  * Build-Dep: added libfribidi-dev, removed libaudiofile-dev

 -- Eduard Bloch <blade@debian.org>  Sat, 05 May 2018 15:01:31 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: x11
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
-Build-Depends: debhelper (>= 9), libxrender-dev, gettext, xfonts-utils, libxft-dev (>> 2.1.1) | libxft2-dev, libsndfile1-dev, libaudiofile-dev, libao-dev, libsm-dev, libx11-dev, libxext-dev, libxinerama-dev, libxrandr-dev, x11proto-core-dev | x-dev, linuxdoc-tools, groff, dpkg-dev (>= 1.16.1~), cmake, asciidoctor, libxpm-dev, libpng-dev, libjpeg-dev (>> 1.2), libglib2.0-dev
+Build-Depends: debhelper (>= 9), libxrender-dev, gettext, xfonts-utils, libxft-dev (>> 2.1.1) | libxft2-dev, libsndfile1-dev, libao-dev, libsm-dev, libx11-dev, libxext-dev, libxinerama-dev, libxrandr-dev, x11proto-core-dev | x-dev, linuxdoc-tools, groff, dpkg-dev (>= 1.16.1~), cmake, asciidoctor, libxpm-dev, libgdk-pixbuf2.0-dev, libglib2.0-dev, libfribidi-dev, librsvg2-dev
+# actually the RSVG is only relevant to detect svg support when pixbuf is used. As of 2018-06-10, SVG loader only works with pixbuf. If not for SVG support, libgdk-pixbuf2.0-dev can be replaced with: libpng-dev, libjpeg-dev (>> 1.2)
 Build-Conflicts: libttf-dev
 Standards-Version: 4.1.1
 Vcs-Git: https://github.com/Code7R/icewm.git
@@ -11,7 +12,7 @@
 Architecture: any
 Conflicts: menu (<< 2.1.9-1)
 Replaces: icewm (<< 1.2.14), icewm-gnome-support (<< 1.3.8-3), icewm-themes (<< 1.3.8-3)
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, sensible-utils
 Recommends: menu, xscreensaver
 Description: wonderful Win95-OS/2-Motif-like window manager
  IceWm is a Window Manager for X Window System. Can emulate the look of
@@ -37,17 +38,16 @@
 
 Package: icewm-lite
 Architecture: any
-Depends: icewm-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
-Provides: x-window-manager
-Description: wonderful Win95-OS/2-Motif-like window manager
+Depends: icewm (= ${binary:Version}), icewm-common (= ${binary:Version}), ${misc:Depends}
+Section: oldlibs
+Description: transitional package for icewm
  IceWm is a Window Manager for X Window System. It is fast and
- memory-efficient, and it provides many different looks including Windows'95,
- OS/2 Warp 3,4, Motif. It tries to take the best features of the above
- systems. Additional features include  multiple workspaces, opaque move/resize,
- task bar, window list, mailbox status, digital clock.
+ memory-efficient, and it provides different looks and some desktop-like
+ functionality.
  .
- This package provides a minimal icewm binary with no support for
- taskbar and antialiased fonts.
+ This package only exists to maintain compatibility to system setups that
+ relied on the former icewm-lite package. It can be safely removed once the
+ system dependencies has been adjusted.
 
 Package: icewm-experimental
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 ICONS=$(CURDIR)/debian/icons
 FDO=$(CURDIR)/debian/fdo
 CUSTOM=$(CURDIR)/debian/custom
-cmakeargs = -DDOCDIR=$(DOCDIR) -DHTMLDIR=$(DOCDIR)/html -DICEHELPIDX=/usr/share/doc/icewm-common/html/icewm.html -DCFGDIR=/etc/X11/icewm -DCMAKE_INSTALL_PREFIX=/usr -DVERSION=$(ORIGVERSION) -DCMAKE_VERBOSE_MAKEFILE=ON
+cmakeargs = -DDOCDIR=$(DOCDIR) -DHTMLDIR=$(DOCDIR)/html -DICEHELPIDX=/usr/share/doc/icewm-common/html/icewm.html -DCFGDIR=/etc/X11/icewm -DCMAKE_INSTALL_PREFIX=/usr -DVERSION=$(ORIGVERSION) -DCMAKE_VERBOSE_MAKEFILE=ON -DICESOUND=AO -DCONFIG_GDK_PIXBUF_XLIB=on -DCONFIG_XPM=off -DCONFIG_LIBPNG=off -DCONFIG_LIBRSVG=on 
 #-DEXTRA_LIBS="-lsupc++" 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
@@ -79,6 +79,7 @@
 	mkdir -p $(ICEWM_COMMON)/usr/bin $(ICEWM_COMMON)/etc/X11/icewm
 	install -m 644 $(CUSTOM)/toolbar $(CUSTOM)/menu $(ICEWM_COMMON)/usr/share/icewm
 	install -m 644 debian/README.cfg $(ICEWM_COMMON)/usr/share/icewm/README
+	install -m 755 debian/netstat.sh $(ICEWM_COMMON)/usr/share/icewm
 	# Extra docs
 	mkdir -p "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ"
 	cd $(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ && sgml2html $(CURDIR)/debian/FAQ/source/*.sgml

## icewm 1.4.3.0~pre-20181030

=== debian/changelog ===
icewm (1.4.3.0~pre-20181030-2) unstable; urgency=low

  * Dropped build and installation of the additional icewm FAQ (wrong
    information is often worse that no information, and FTBFS fix due to
    removed linuxdoc-tools dependency)

 -- Eduard Bloch <blade@debian.org>  Wed, 31 Oct 2018 12:25:51 +0100

icewm (1.4.3.0~pre-20181030-1) unstable; urgency=low

  * New upstream snapshot
  * Reverting terminal wrapper on some utility functionality to upstream
    default (xterm) to avoid incompatibilities with some x-terminal-emulator
    providers
  * Cleanup of some old dependencies, no longer used in this branch

 -- Eduard Bloch <blade@debian.org>  Tue, 30 Oct 2018 22:05:40 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: x11
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
-Build-Depends: debhelper (>= 9), libxrender-dev, gettext, xfonts-utils, libxft-dev (>> 2.1.1) | libxft2-dev, libsndfile1-dev, libao-dev, libsm-dev, libx11-dev, libxext-dev, libxinerama-dev, libxrandr-dev, x11proto-core-dev | x-dev, linuxdoc-tools, groff, dpkg-dev (>= 1.16.1~), cmake, asciidoctor, libxpm-dev, libgdk-pixbuf2.0-dev, libglib2.0-dev, libfribidi-dev, librsvg2-dev
+Build-Depends: debhelper (>= 9), libxrender-dev, gettext, libxft-dev (>> 2.1.1) | libxft2-dev, libsndfile1-dev, libao-dev, libsm-dev, libx11-dev, libxext-dev, libxinerama-dev, libxrandr-dev, x11proto-core-dev | x-dev, dpkg-dev (>= 1.16.1~), cmake, asciidoctor, libxpm-dev, libgdk-pixbuf2.0-dev, libglib2.0-dev, libfribidi-dev, librsvg2-dev
 # actually the RSVG is only relevant to detect svg support when pixbuf is used. As of 2018-06-10, SVG loader only works with pixbuf. If not for SVG support, libgdk-pixbuf2.0-dev can be replaced with: libpng-dev, libjpeg-dev (>> 1.2)
 Build-Conflicts: libttf-dev
 Standards-Version: 4.1.1
@@ -13,7 +13,7 @@
 Conflicts: menu (<< 2.1.9-1)
 Replaces: icewm (<< 1.2.14), icewm-gnome-support (<< 1.3.8-3), icewm-themes (<< 1.3.8-3)
 Depends: ${misc:Depends}, ${shlibs:Depends}, sensible-utils
-Recommends: menu, xscreensaver
+Recommends: menu, xscreensaver, xterm
 Description: wonderful Win95-OS/2-Motif-like window manager
  IceWm is a Window Manager for X Window System. Can emulate the look of
  Windows'95, OS/2 Warp 3,4, Motif. Tries to take the best features of the above

=== debian/rules ===
--- 
+++ 
@@ -81,9 +81,9 @@
 	install -m 644 debian/README.cfg $(ICEWM_COMMON)/usr/share/icewm/README
 	install -m 755 debian/netstat.sh $(ICEWM_COMMON)/usr/share/icewm
 	# Extra docs
-	mkdir -p "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ"
-	cd $(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ && sgml2html $(CURDIR)/debian/FAQ/source/*.sgml
-	sgml2txt $(CURDIR)/debian/FAQ/source/*.sgml && col -bx < IceWM-FAQ.txt > $(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ/IceWM-FAQ.txt
+	#mkdir -p "$(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ"
+	#cd $(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ && sgml2html $(CURDIR)/debian/FAQ/source/*.sgml
+	#sgml2txt $(CURDIR)/debian/FAQ/source/*.sgml && col -bx < IceWM-FAQ.txt > $(ICEWM_COMMON)/usr/share/doc/icewm-common/FAQ/IceWM-FAQ.txt
 	cd debian ; for x in icewm icewm-lite icewm-experimental ; do mkdir -p $$x/usr/share/lintian/overrides ; cp $$x.lintian $$x/usr/share/lintian/overrides/$$x ; done	
 	sed -e 's,^.link.*fonts.googleapis.*,,' -i "$(ICEWM_COMMON)/usr/share/doc/icewm-common/html/"*.html
 	dh_link -A

## icewm 1.5.5+git20190610

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -71,7 +71,7 @@
 option(CONFIG_RENDER "Define to enable XRENDER extension" on)
 option(CONFIG_XRANDR "Define to enable XRANDR extension" on)
 option(CONFIG_SESSION "Define to enable X session management" on)
-option(CONFIG_EXTERNAL_TRAY "Define to build tray support in standalone executable" off)
+option(CONFIG_EXTERNAL_TRAY "Define for external systray (unsupported)" off)
 option(ENABLE_NLS "Enable Native Language Support" on)
 option(ENABLE_LTO "Enable Link Time Optimization" off)
 
@@ -158,7 +158,6 @@
 CHECK_INCLUDE_FILE_CXX(locale.h HAVE_LOCALE_H)
 CHECK_INCLUDE_FILE_CXX(netdb.h HAVE_NETDB_H)
 CHECK_INCLUDE_FILE_CXX(netinet/in.h HAVE_NETINET_IN_H)
-CHECK_INCLUDE_FILE_CXX(sndfile.h HAVE_SNDFILE_H)
 CHECK_INCLUDE_FILE_CXX(stddef.h HAVE_STDDEF_H)
 CHECK_INCLUDE_FILE_CXX(stdlib.h HAVE_STDLIB_H)
 CHECK_INCLUDE_FILE_CXX(string.h HAVE_STRING_H)
@@ -325,7 +324,8 @@
 #clear cache
 set(ENABLE_ALSA off)
 set(ENABLE_AO off)
-set(ENABLE_ESD off)
 set(ENABLE_OSS off)
 set(audio_libs )
 set(audio_flags )
+# Triggers some cmake bug, use copy-pasta for now
+#macro(_addsnd varname flagname)

=== debian/changelog ===
icewm (1.5.5+git20190610-1) unstable; urgency=medium

  * A new upstream snapshot (basically version 1.5.5 with fixes)

 -- Eduard Bloch <blade@debian.org>  Mon, 10 Jun 2019 13:02:58 +0200

## icewm 1.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,5 @@
 cmake_minimum_required(VERSION 2.6)
-IF (POLICY CMP0053) # in CMake 3.1.0+
-  CMAKE_POLICY (SET CMP0053 OLD) # keep old-style @VAR@ expansion
-ENDIF (POLICY CMP0053)
+CMAKE_POLICY (SET CMP0053 NEW)
 PROJECT(ICEWM CXX C)
 
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -12,9 +12,9 @@
 INCLUDE(CheckCXXSourceCompiles)
 INCLUDE(CheckCXXCompilerFlag)
 
-SET(CXXFLAGS_COMMON "-pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -I. -DHAVE_CONFIG_H")
-
-set(icewm_img_libs "")
+SET(CXXFLAGS_COMMON -pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -DHAVE_CONFIG_H -include "${CMAKE_BINARY_DIR}/config.h")
+include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
+
 set(icewm_libs "")
 
 if("${CMAKE_BUILD_TYPE}" STREQUAL "" AND ("" STREQUAL "${CMAKE_CXX_FLAGS}"))
@@ -22,39 +22,38 @@
 endif()
 
 if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
+    CHECK_CXX_COMPILER_FLAG(-std=gnu++98 CXX_FORCELEGACY)
+    if(CXX_FORCELEGACY)
+        list(APPEND CXXFLAGS_COMMON -std=gnu++98)
+    endif()
     add_definitions(-DDEBUG)
 endif()
-
-# carefully splicing of command line arguments, even from lists
-macro(_append varname)
-    string(REPLACE ";" " " _apx "${ARGN}")
-    if(NOT DEFINED ${varname})
-        set(${varname} "${_apx}")
-    else()
-        set(${varname} "${${varname}} ${_apx}")
-    endif()
-endmacro()
 
 # I don't need -rdynamic, thanks!
 SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
 SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
 
-# apply to test calls
-SET(CMAKE_REQUIRED_FLAGS ${CXXFLAGS_COMMON})
+SET(CMAKE_REQUIRED_FLAGS )
 
 CHECK_CXX_COMPILER_FLAG(-fvisibility=hidden CXX_VHI)
 if(CXX_VHI)
-    _append(CXXFLAGS_COMMON -fvisibility=hidden)
+    list(APPEND CXXFLAGS_COMMON -fvisibility=hidden)
 endif()
 
 CHECK_CXX_COMPILER_FLAG(-fvisibility-inlines-hidden CXX_VIHI)
 if(CXX_VIHI)
-    _append(CXXFLAGS_COMMON -fvisibility-inlines-hidden)
-endif()
-
-CHECK_CXX_COMPILER_FLAG(-std=gnu++98 CXX_FORCELEGACY)
-if(CXX_FORCELEGACY)
-    _append(CXXFLAGS_COMMON -std=gnu++98)
+    list(APPEND CXXFLAGS_COMMON -fvisibility-inlines-hidden)
+endif()
+
+# teach GCC7+ to interpret our comments
+CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough=2 HAS_FALLTHROUGH_OPTION)
+if(HAS_FALLTHROUGH_OPTION)
+    list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough=2)
+else()
+    CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough HAS_FALLTHROUGH_OPTION)
+    if(HAS_FALLTHROUGH_OPTION)
+        list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough)
+    endif()
 endif()
 
 #CHECK_CXX_COMPILER_FLAG(-Wl,-fuse-ld=gold CXX_LINKER_GOLD)
@@ -97,7 +96,7 @@
 endif()
 
 if(ENABLE_LTO)
-    set(CXXFLAGS_COMMON "${CXXFLAGS_COMMON} -flto")
+    list(APPEND CXXFLAGS_COMMON -flto)
     list(APPEND EXTRA_LIBS -flto)
 endif()
 
@@ -190,8 +189,14 @@
 #########################################################
 
 pkg_check_modules(fontconfig fontconfig)
+pkg_check_modules(xrender xrender)
+pkg_check_modules(xcomposite xcomposite)
+pkg_check_modules(xdamage xdamage)
+pkg_check_modules(xfixes xfixes)
 pkg_check_modules(xext xext)
 pkg_check_modules(x11 x11)
+
+set(icewm_img_libs ${xrender_LDFLAGS} ${xcomposite_LDFLAGS} ${xdamage_LDFLAGS} ${xfixes_LDFLAGS})
 
 # XXX: the image loader selection became a big mess but it is hard to revert now
 # It would have been a better idea to use different names for the user-specified
@@ -291,15 +296,6 @@
         message(WARNING "Xrandr library not found, disabling CONFIG_XRANDR")
         set(CONFIG_XRANDR off)
     ENDIF()
-endif()
-
-if(CONFIG_RENDER)
-    pkg_check_modules(xrender xrender)
-    IF(NOT xrender_FOUND)
-        message(WARNING "Xrender library not found, disabling CONFIG_RENDER")
-        set(CONFIG_RENDER off)
-    ENDIF()
-    LIST(APPEND icewm_img_libs ${xrender_LDFLAGS})
 endif()
 
 option(CONFIG_COREFONTS "Define to enable X11 core fonts" off)
@@ -324,8 +320,3 @@
 #clear cache
 set(ENABLE_ALSA off)
 set(ENABLE_AO off)
-set(ENABLE_OSS off)
-set(audio_libs )
-set(audio_flags )
-# Triggers some cmake bug, use copy-pasta for now
-#macro(_addsnd varname flagname)

=== debian/changelog ===
icewm (1.6.1) unstable; urgency=medium

  * antiX buster build 

 -- anticapitalista <antix@operamail.com>  Thu, 05 Sep 2019 23:09:51 +0100
